#!/usr/local/bin/perl

print "Content-type: text/html\n\n";

# Decode the user data and place it in the
# data_received associative array.
$user_string = $ENV{'QUERY_STRING'};

# This line changes the + signs to spaces.
$user_string =~ s/\+/ /g;

# This line places each name/value pair as a separate
# element in the name_value_pairs array.
@name_value_pairs = split(/&/, $user_string);

# This code loops over each element in the name_value_pairs
# array, splits it on the = sign, and places the value
# into the user_data associative array with the name as the
# key.
foreach $t_name (@name_value_pairs) {
  # These two lines decode the values from any URL
  # hexadecimal encoding. The first section searches for a
  # hexadecimal number and the second part converts the
  # hex number to decimal and returns the character
  # equivalent.
  $name = $t_name;
  $name =~
    s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/ge;
}
 $mysrcfile = $ENV{'REMOTE_ADDR'};
 $flag = 0;
 $srcfile = '../../tmp/mccat.src'.'.'.$mysrcfile.'.html';
 #print "$srcfile";
 open (FILE, "<$srcfile") || die "can't open $srcfile";
 $entity = "Statement";
 while ($line = <FILE>){
  if ($line=~/\?$name/)
  {
   $srcline = $line;
   if ($srcline=~NAME) 
   {
    $entity ="Function";
    while ($line = <FILE>)
    {
      if ($line eq "{\n")
      {
	last;
      }
      $srcline = $srcline.$line;
    }
   }
   last;
  }
 }
# ($head, $tail) = split(/>/, $srcline);
# ($stmt, $linktail) = split(/</, $tail);
$stmt = $srcline;

 $file = '../../tmp/mccat.info'.'.'.$mysrcfile.'.html';

 #print "$file";
 open (FILE, "<$file") || die "can't open $file";
 print "<HTML>";
 print "<BODY bgcolor=white>";
 print "<BASE HREF=\"http://www-acaps.cs.mcgill.ca/\">\n";
 while ($line = <FILE>) {
  if ($line =~"INFOHEADER") {
   if ($line=~"alias_indirect"){
     if ($entity eq "Function")
     {
       print "You have clicked on a <FONT color=red>function header</FONT>.";
       print "<BR> <FONT color=blue>Alias Indirect</FONT> information";
       print " is not relevant here.";
       last;
     }
     print "<FONT color=red>Points-to</FONT> relationships for the";
     print " <FONT color=blue> indirect references</FONT> at statement:<BR>";
     print "<PRE><FONT color=blue>$stmt</FONT></PRE>";
     while ($line = <FILE>) {
      if ($line=~$name){
	 ($header, $al_ind_info) = split(/:/, $line);
	 (@main_ptr_strings) = split(/!/, $al_ind_info);
	 foreach $main_ptr_string (@main_ptr_strings){
          if ($main_ptr_string=~"Bottom"){
           print "<HR>";
           $flag = 1;
	   print "No points-to information is available for this";
           print " statement.<BR>";
	   print "Either the function containing it is never called,";
           print " or it is simple dead code.<BR>";
	   last;
	   }
          if ($main_ptr_string=~"Empty"){
           print "<HR>";
           $flag = 1;
	   print "No points-to information is available for this";
           print " statement.<BR>";
	   print "Probably the dereferenced pointers are not initialized,";
           print " or they point-to non-program variables.<BR>";
	   last;
	   }
	  ($main_ptr, $al_pair_string) = split(/=/, $main_ptr_string);
	  (@al_pairs) = split(/&/, $al_pair_string); 
	  print"<HR>";
	  print "Pointer <FONT color=red size=+1>";
	  print "$main_ptr:</FONT>";
	  print "<UL>";
	  foreach $al_pair (@al_pairs) {
	    ($ptr, $type) = split(/,/, $al_pair);
	    print "<LI>";
	    if ($type eq "D\n") {
	     $flag = 1;
	     print "<FONT color = fuchsia>Definitely</FONT> points-to variable";
	     print "<FONT color=blue size=+1>";
	     print "<EM> $ptr</EM></FONT><BR>";
	    }
	    elsif ($type eq "D") {
	     $flag = 1;
	     print "<FONT color = fuchsia>Definitely</FONT> points-to variable";
	     print " <FONT color=blue size=+1>";
	     print "<EM> $ptr</EM></FONT><BR>";
	    }
	    elsif ($type eq "P\n" ){
	     $flag = 1;
	     print "<FONT color =yellow >Possibly</FONT> points-to variable";
	     print "<FONT color=blue size=+1>";
	     print "<EM> $ptr</EM></FONT><BR>";
	    }
            elsif ($type eq "P"){
	     $flag = 1;
	     print "<FONT color =yellow >Possibly</FONT> points-to variable";
	     print "<FONT color=blue size=+1>";
	     print "<EM> $ptr</EM></FONT><BR>";
	    }
	    else{
	     print "ptr $ptr <BR>";
	     print "type $type <BR>";
	     print "Something is Wrong<BR>";
	    }
	   }
	   print "</UL>";
          }
	  print"<HR>";
	 }
      }
      if ($flag eq 0){
       print "<HR>";
       print "Statement does not involve an indirect reference.<BR>";
       print "<HR>";
     } 
   }
   elsif ($line=~"simple_alias")
   {
     if ($entity eq "Function")
     {
     print "<FONT color=red>Points-to</FONT> relationships valid at";
     print " the exit of the function:<BR>";
     print "<PRE><FONT color=blue>$stmt</FONT></PRE>";
     print "<HR>";
     }
     else
     {
     print "<FONT color=red>Points-to</FONT> relationships for the";
     print " statement:<BR>";
     print "<PRE><FONT color=blue>$stmt</FONT></PRE>";
     print "<HR>";
     }
     while ($line = <FILE>) {
      if ($line=~$name){
	 ($header, $al_ind_info) = split(/:/, $line);
          if ($al_ind_info=~"Bottom"){
           $flag = 1;
	   if ($entity eq "Function")
	   {
	   print "No points-to information is available at the exit of";
           print " this function.<BR>";
	   print "Probably this function is not in the call graph.";
	   last;
	   }
	   else
	   {
	   print "No points-to information is available for this";
           print " statement.<BR>";
	   print "Probably the function containing it is never called,";
           print " or it is simple dead code.<BR>";
	   last;
	   }
	   }
	 if ($al_ind_info=~"Empty"){
	   $flag = 1;
	   if ($entity eq "Function")
	   {
	  print "No points-to relationships exist at the exit of this function";
	   }
	   else
	   {
	   print "No points-to relationships exist at this statement";
	   }
	 }
	 (@main_ptr_strings) = split(/&/, $al_ind_info);
	 $counter = 0;
	 foreach $main_ptr_string (@main_ptr_strings){
	  ($ptr, $pointed, $type) = split(/,/, $main_ptr_string);
	  if ($ptr=~argv){next;}
	  $counter++;
	  print "  (<FONT color=red>$ptr</FONT>, ";
	  print "<FONT color=blue>$pointed</FONT>, ";
	  if ($type=~"D"){
	   print "<FONT color=fuchsia>$type</FONT>";
          }
	  else{
	   print "<FONT color=yellow>$type</FONT>";
	   }
	  if ($counter eq 2){
	   $counter = 0;
	   print ")<BR>";
          }
	  else{
	   print ") ";
	  }
         }
	 print "<HR>";
       }
     }
   }
  elsif ($line=~"connect_indirect")
  {
    if ($entity eq "Function")
    {
       print "You have clicked on a <FONT color=red>function header</FONT>.";
       print "<BR> <FONT color=blue>Connect Indirect</FONT> information";
       print " is not relevant here.";
       last;
    }
    while ($line = <FILE>) {
    if ($line=~$name){
        print "<FONT color=red>Connection</FONT> relationships for the";
        print " <FONT color=blue> indirect references</FONT> at statement:<BR>";
        print "<PRE><FONT color=blue>$stmt</FONT></PRE>";
	($header, $al_ind_info) = split(/:/, $line);
	(@main_ptr_strings) = split(/!/, $al_ind_info);
	foreach $main_ptr_string (@main_ptr_strings){
          if ($main_ptr_string=~"Bottom"){
           print "<HR>";
           $flag = 1;
	   print "No connection information is available for this";
           print " statement.<BR>";
	   print "Probably the function containing it is never called,";
           print " or it is simple dead code.<BR>";
	   last;
	   }
        if ($main_ptr_string=~"Empty"){
           print "<HR>";
           $flag = 1;
	   print "No connection information is available for this";
           print " statement.<BR>";
	   print "Probably the dereferenced pointers are not initialized.<BR>";
	   last;
	   }
	($main_ptr, $al_pair_string) = split(/=/, $main_ptr_string);
	(@al_pairs) = split(/,/, $al_pair_string); 
	 print"<HR>";
	 print "Pointer <FONT color=red >";
	 print "$main_ptr</FONT> is connected with";
         print " pointers:<BR>";
	 $counter = 0;
	 foreach $ptr (@al_pairs) {
           $flag = 1;
	   #if ($ptr=~"anchor"){
	   # next; #don't print anchor handles
	   #}
           if ($counter eq 0){
	    print "<FONT color=blue >$ptr</FONT>";
	   }
 	   else
	   {
	    print "<FONT color=blue >, $ptr</FONT>";
	   }
	   $counter++;
	 }
        }
        print"<HR>";
       }
      }
     if ($flag eq 0){
       print "<HR>";
       print "Statement does not involve an <FONT color=red>indirect";
       print " reference</FONT> ";
       print "to the <FONT color=blue>heap</FONT>.<BR>";
       print "<HR>";
     } 
   }
   elsif ($line=~"simple_connect")
   {
    while ($line = <FILE>) {
    if ($line=~$name){
     if ($entity eq "Function")
     {
     print "<FONT color=red>Connection</FONT> relationships valid at";
     print " the beginning of the function:<BR>";
     print "<PRE><FONT color=blue>$stmt</FONT></PRE>";
     print "<HR>";
     }
     else
     {
     print "<FONT color=red>Connection</FONT> relationships for the";
     print " statement:<BR>";
     print "<PRE><FONT color=blue>$stmt</FONT></PRE>";
     print "<HR>";
     }
	($header, $al_ind_info) = split(/:/, $line);
	(@main_ptr_strings) = split(/!/, $al_ind_info);
	foreach $main_ptr_string (@main_ptr_strings){
	  if ($al_ind_info=~Bottom){
           print "<HR>";
           $flag = 1;
	   if ($entity eq "Function")
	   {
	   print "No connection information is available at the beginning of";
           print " this function.<BR>";
	   print "Probably this function is not in the call graph.";
	   last;
	   }
	   else
	   {
	   print "No connection information is available for this";
           print " statement.<BR>";
	   print "Probably the function containing it is never called,";
           print " or it is simple dead code.<BR>";
	   last;
	   }
	  }
	 if ($al_ind_info=~"Empty"){
           print "<HR>";
           $flag = 1;
	   if ($entity eq "Function")
	   {
	   print "No connection information is available at the beginning";
           print " of this function.<BR>";
	   print "Probably heap pointers are not yet initialized.<BR>";
	   last;
	   }
	   else
	   {
	   print "No connection information is available for this";
           print " statement.<BR>";
	   print "Heap pointers are not yet initialized.<BR>";
	   last;
	   }
	  }
	($main_ptr, $al_pair_string) = split(/=/, $main_ptr_string);
	#if ($main_ptr=~"anchor"){
	#    next; #don't print anchor handle info
	# }
	(@al_pairs) = split(/,/, $al_pair_string); 
	 print"<HR>";
	 print "(<FONT color=red >";
	 print "$main_ptr</FONT>";
	 $counter = 0;
	 foreach $ptr (@al_pairs) {
           $flag = 1;
	   #if ($ptr=~"anchor"){
	   # next; #don't print anchor handles
	   #}
	   if ($ptr eq "\n"){
	    next; #don't print comma when not required
	   }
	    print "<FONT color=blue>, $ptr</FONT>";
	 }
	 print ")<BR>";
        }
        print"<HR>";
       }
      }
      if ($flag eq 0)
      {
       print "<HR>";
       print "No connection relationships at this $entity. ";
       print "Either the $entity is dead code or heap"; 
       print " pointers are not yet initialized.<BR>";
       print "<HR>";
      }
   }
  elsif ($line=~"heap_rw_sets")
  {
    while ($line = <FILE>) {
     if ($line=~"CSTRFILE"){
      ($cstrhdr, $cstrfile) = split(/=/, $line);
     }
     if ($line=~$name){
      if ($line=~"func") 
      {
        print "<FONT color=red>Heap Read-Write information</FONT> for the function:";
        print "<PRE><FONT color=blue>$stmt</FONT></PRE>";
      }
      else
      {
        print "<FONT color=red>Heap Read/Write information</FONT> for the statement:";
        print "<PRE><FONT color=blue>$stmt</FONT></PRE>";
      }
	($header, $al_ind_info) = split(/:/, $line);
        if ($al_ind_info eq "\n" ){
           print "<HR>";
           $flag = 1;
	   if ($line=~"func"){
	    print "This function does not access the heap.<BR>";
	   }
	   else{
	    print "This statement does not access the heap.<BR>";
	   }
	   last;
         }
        elsif ($al_ind_info =~ "Empty" ){
           print "<HR>";
           $flag = 1;
	   if ($line=~"func"){
	    print "This function does not access the heap.<BR>";
	   }
	   else{
	    print "This statement does not access the heap.<BR>";
	   }
	   last;
         }
	(@main_ptr_strings) = split(/!/, $al_ind_info);
	 $maincounter = 0;
	 foreach $main_ptr_string (@main_ptr_strings){
	 if ($main_ptr_string eq "")
	 {
	   $maincounter++;
	   next;
	 }
	 elsif ($main_ptr_string eq "\n")
	 {
	   $maincounter++;
	   next;
	 }
	 elsif ($main_ptr_string eq "=x/x")
	 {
	   $maincounter++;
	   next;
	 }
	 elsif ($main_ptr_string eq "=x/x\n")
	 {
	   $maincounter++;
	   next;
	 }
         (@tpstrings) = split(/&&/, $main_ptr_string);
	 $new_ptr_list_counter = 0;
	 foreach $tpstring (@tpstrings){
	     $new_ptr_list_counter++;
	   }
	 if ($new_ptr_list_counter > 0){
	    print "<HR>";
	    if ($maincounter eq 0){
	     print "<FONT color=blue>Read Anchors:</FONT> <FONT color=black>";
	     }
            else{
	    print "<FONT color=blue>Write Anchors:</FONT> <FONT color=black>";
	    }
	   print "<ul>";
	   $flag = 1;
          }
          else {next;}
         foreach $tpstring (@tpstrings){
	 print "<li>";
	 ($main_ptr_str, $field_str) = split(/=/, $tpstring);
	 #print"<HR>";
	 (@main_ptr_list) = split(/,/, $main_ptr_str);
	  $ptr_list_counter = 0;
	  foreach $main_ptr (@main_ptr_list){
	     if ($main_ptr=~"return")
	      {next;}
	     if ($main_ptr=~"anchor"){
	      (@new_main_ptrs) = split(/_/, $main_ptr);
	      $counter = 0;
	      foreach $new_main_ptr (@new_main_ptrs){
	       $ssa_num = $new_main_ptr; 
	       $counter++;
	       }
	       $main_ptr = $new_main_ptrs[1];
	       for ($t = 2; $t < $counter-1; $t++){ 
	        $main_ptr = $main_ptr.'_'.$new_main_ptrs[$t];
	       }
	     }
	     elsif ($main_ptr=~"0+"){
	      (@new_main_ptrs) = split(/\+/, $main_ptr);
              #$ssa_num = "@func_entry"; 
              $ssa_num = 0; 
              $main_ptr = $new_main_ptrs[1];
	     }
	     if ($ptr_list_counter == 0){
	      if ($ssa_num eq "@func_entry")
	       {print "$main_ptr$ssa_num";}
              else
	       {print "$main_ptr<FONT color=blue><SUB>$ssa_num</SUB></FONT>";}
	     }
             else{
	      if ($ssa_num eq "@func_entry")
	      {print ", $main_ptr$ssa_num";}
              else
	       {print ", $main_ptr<FONT color=blue><SUB>$ssa_num</SUB></FONT>";}
	     }
	     $ptr_list_counter++;
	    }
	   print "</FONT>:<BR>";
	 (@rw_strings) = $field_str; 
	 $rwcounter = 0;
	 printf "<UL>";
	 foreach $rw_str (@rw_strings){
	  (@vpstrings) = split(/\//, $rw_str);
	   $vpcounter = 0;
	   foreach $vpstr (@vpstrings) {
            if ($vpstr eq "x"){
	     $vpcounter++;
	     next;
	    }
	    elsif ($vpstr eq "x\n"){
	     $vpcounter++;
	     next;
	    }
	    else {
	      if ($vpcounter eq 0) {
	       print "<LI><FONT color=yellow>Pointer Fields: </FONT>";
	      }
	      else{
	       print "<LI><FONT color=magenta>Value Fields: </FONT>";
	      }
	    (@field_pairs) = split(/{/, $vpstr);
	    foreach $field_pair (@field_pairs){
	     ($field, $struct) = split(/,/, $field_pair);
	      ($fieldname, $fieldnum) = split(/~/, $field);
	      ($structname, $structnum) = split(/~/, $struct);
	 print "<BR>(<EM><A HREF=\"$cstrfile#$fieldnum\">$fieldname</a>,</EM> ";
	     print "<A HREF=\"$cstrfile#$structnum\">$structname</a>) ";
	   }
          }
	   $vpcounter++;
	 }
	 print "</UL>";
         $rwcounter++;
        }
	print "<BR>";
       }
	if ($new_ptr_list_counter > 0)
	 {print "</ul>";}
        $maincounter++;
	}
       }
      }
      if ($flag eq 1)
       { print "<HR>"; }
     if ($flag eq 0){
       print "<HR>";
       print "$entity does not involve <FONT color=red>";
       print " accesses</FONT> ";
       print "to the <FONT color=blue>heap</FONT> or is ";
       print " dead code.<BR>";
       print "<HR>";
      }
   }
   elsif ($line=~"rw_sets")
   {
     if ($entity eq "Function")
     {
     print "<FONT color=red>Read-Write</FONT> information";
     print " for the function:<BR>";
     print "<PRE><FONT color=blue>$stmt</FONT></PRE>";
     print "<HR>";
     }
     else
     {
     print "<FONT color=red>Read-Write</FONT> information for the";
     print " statement:<BR>";
     print "<PRE><FONT color=blue>$stmt</FONT></PRE>";
     print "<HR>";
     }
     $flag = 0;
     while ($line = <FILE>) {
      if ($line=~$name){
           $flag = 1;
	 ($header, $al_ind_info) = split(/:/, $line);
          if ($al_ind_info eq "\n"){
           $flag = 1;
	   if ($entity eq "Function")
	   {
	   print "No read-write information is available for";
           print " this function.<BR>";
	   print "Probably this function is not in the call graph.";
	   last;
	   }
	   else
	   {
	   print "No read-write information is available for this";
           print " statement.<BR>";
	   print "Probably the function containing it is never called,";
           print " or it is simple dead code.<BR>";
	   last;
	   }
	   }
	 (@main_ptr_strings) = split(/\|/, $al_ind_info);
	 for ($counter = 0; $counter < 2; $counter++){
	  print "<BR>";
	  if ($counter == 0){
	   print "<FONT color=red>Read Set: </FONT>";
	  }
	  if ($counter == 1){
	   print "<FONT color=red>Write Set: </FONT>";
	  }
	  $mycounter = 0;
	 for ($localcounter = 0; $localcounter < 3; $localcounter+=2){
	  $main_ptr_string = $main_ptr_strings[$counter + $localcounter];
	   if (!$main_ptr_string){next;}
	   if ($main_ptr_string eq "\n"){next;}
	  (@vars) = split(/,/, $main_ptr_string);
	  foreach $var (@vars){
	   #if ($var=~"al_string_cst"){next;}
	   #if ($var=~"al_file"){next;}
	   if ($mycounter > 2){
	    print "<BR>";
	    $mycounter = 0;
	   }
	   if ($mycounter == 0){
	    print "<FONT color=blue>$var</FONT>";
	   }
	   else
	   {
	    print "<FONT color=blue>,</FONT><FONT color=blue> $var </FONT>";
	   }
	   $mycounter++;
	  }
        }
      }	
     }
    }
    if ($flag == 0){
     print "Cannot find the stmt in the dump";
    }
   }
  elsif ($line=~"connect_fields")
  {
    while ($line = <FILE>) {
     if ($line=~"CSTRFILE"){
      ($cstrhdr, $cstrfile) = split(/=/, $line);
     }
     if ($line=~$name){
      if ($line=~"func") 
      {
        print "<FONT color=red>Field sets</FONT> for the function:";
        print "<PRE><FONT color=blue>$stmt</FONT></PRE>";
      }
      else
      {
        print "<FONT color=red>Field sets</FONT> for the statement:";
        print "<PRE><FONT color=blue>$stmt</FONT></PRE>";
      }
	($header, $al_ind_info) = split(/:/, $line);
	(@global_param_strs) = split(/}/, $al_ind_info);
	$gpcounter = 0;
	foreach $gpstr (@global_param_strs){
	 if ($line=~func){
	  if ($gpcounter == 0){
           if ($gpstr eq "x"){
	    #print "<H2> No field accesses with respect to globals and";
	    #print " their anchors.</H2>";
	    print "<HR>";
	    $gpcounter++;
	    next;
           }
	   else{
	    #print "<H2> Field accesses with respect to globals and";
	    #print " their anchors.</H2>";
	    print "<H2> Field accesses with respect to anchors for";
            print " global variables";
	   }
	  }
	  elsif($gpcounter == 1){
           if ($gpstr eq "x"){
	    $flag = 1;
	    #print "<H2> No field accesses with respect to parameters and";
	    #print " their anchors.</H2>";
	    print "<H2> No field accesses with respect to parameter anchors";
	    $gpcounter++;
	    lastt;
           }
           elsif ($gpstr eq "x\n"){
	    $flag = 1;
	    print "<H2> No field accesses with respect to parameter anchors";
	    #print "<H2> No field accesses with respect to parameters and";
	    #print " their anchors.</H2>";
	    $gpcounter++;
	    last;
           }
	   else{
	    #print "<H2> Field accesses with respect to parameters and";
	    #print " their anchors.</H2>";
	    print "<H2> Field accesses with respect to parameter";
	    print "  anchors.</H2>";
	   }
	  }
	  else {
	   print "Something is wrong with gpcounter: $gpcounter";
           last;
          }
         }
	 (@main_ptr_strings) = split(/!/, $gpstr);
	 foreach $main_ptr_string (@main_ptr_strings){
          if ($main_ptr_string eq "\n"){
           print "<HR>";
           $flag = 1;
	   if ($line=~"func"){
	    print "This function does not access fields with respect to";
	    print " heap-directed global and parameter pointers.<BR>";
	   }
	   else{
	    print "This statement does not involve field accesses";
	    print " to the heap.<BR>";
	   }
	   last;
	   }
          $flag = 1;
	 ($main_ptr_str, $field_str) = split(/=/, $main_ptr_string);
	 print"<HR>";
	 if ($main_ptr_str=~"\"")
	 {
	   ($tt, $main_ptr) = split(/"/, $main_ptr_str);
	   #print "Pointer <FONT color=red >$main_ptr</FONT>"; 
	   #print " and anchor <FONT color=red >$main_ptr@func_entry";
	   print "Anchor <FONT color=red >$main_ptr@func_entry";
	   print "</FONT>:<BR>"; 
	 }
	 else
	 {
           if ($main_ptr_str=~"@"){
	    ($tt, $main_ptr) = split(/@/, $main_ptr_str);
	     print "Anchor <FONT color=red >$main_ptr@func_entry</FONT>:<BR>"; 
	   }
	   else {
	    (@main_ptr_list) = split(/,/, $main_ptr_str);
	    $ptr_list_counter = 0;
	    foreach $main_ptr (@main_ptr_list){
             #if ($main_ptr=~anchor) 
             #{next;} # don't print anchor info
             #if ($main_ptr=~"return") 
             #{next;} # don't print anchor info
	     $ptr_list_counter++;
	    }
	    if ($ptr_list_counter > 1){
	      print "Pointers <FONT color=red>";
            }
	    elsif ($ptr_list_counter ==1){
	      print "Pointer <FONT color=red>";
	    }
            else {next;}
	    $ptr_list_counter = 0;
	    foreach $main_ptr (@main_ptr_list){
	     if ($main_ptr=~"anchor")
	      {next;}
	     if ($main_ptr=~"return")
	      {next;}
	     if ($ptr_list_counter == 0)
	      {print $main_ptr;}
             else
	      {print ", $main_ptr";}
	     $ptr_list_counter++;
	    }
	   print "</FONT>:<BR>";
	   }
	 }
	 (@rw_strings) = split(/&&/, $field_str); 
	 $rwcounter = 0;
	 printf "<UL>";
	 foreach $rw_str (@rw_strings){
	  (@vpstrings) = split(/\//, $rw_str);
	   $vpcounter = 0;
	    if ($rwcounter eq 0){
	       print "<LI><FONT color=blue>Read Fields: </FONT>";
	       print "<UL>";
            }
	    else{
	       print "<LI><FONT color=red>Write Fields: </FONT>";
	       print "<UL>";
            }
	   foreach $vpstr (@vpstrings) {
            if ($vpstr eq "x"){
	     $vpcounter++;
	     next;
	    }
	    elsif ($vpstr eq "x\n"){
	     $vpcounter++;
	     next;
	    }
	    else {
	     if ($vpcounter eq 0) {
	      print "<LI><FONT color=yellow>Pointer: </FONT>";
	     }
	     else{
	      print "<LI><FONT color=magenta>Value: </FONT>";
	     }
	    (@field_pairs) = split(/{/, $vpstr);
	    foreach $field_pair (@field_pairs){
	     ($field, $struct) = split(/,/, $field_pair);
	      ($fieldname, $fieldnum) = split(/~/, $field);
	      ($structname, $structnum) = split(/~/, $struct);
	 print "<BR>(<EM><A HREF=\"$cstrfile#$fieldnum\">$fieldname</a>,</EM> ";
	     print "<A HREF=\"$cstrfile#$structnum\">$structname</a>) ";
	   }
          }
	   $vpcounter++;
	 }
	 print "</UL>";
         $rwcounter++;
        }
	printf "</UL>";
	}
	$gpcounter++;
       }
       print "<HR>";
      }
     } 
     if ($flag eq 0){
       print "<HR>";
       print "$entity does not involve <FONT color=red>field";
       print " accesses</FONT> ";
       print "to the <FONT color=blue>heap</FONT> or is ";
       print " dead code.<BR>";
       print "<HR>";
      }
   }
   else
   {
     print "Info header: $line <BR>";
     print "Something is wrong<BR>";
   }
  }
 }
# if ($flag eq 0){
#  print "This flow information is not relevant/available for this Statement";
#  } 
 print "</HTML>";
